local PARTOF = "Part of"

local item2set = {}
local function tt(tooltip, ...)
	local _, itemLink = tooltip:GetItem()
	if not itemLink then return end
	local itemId = tonumber((select(3, itemLink:find("item:(%d+):"))))
	if not itemId then return end
	if item2set[itemId] then
		tooltip:AddDoubleLine(PARTOF, item2set[itemId])
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("EQUIPMENT_SETS_CHANGED")
f:RegisterEvent("PLAYER_LOGIN")
f:SetScript("OnEvent", function()
	for i = 1, GetNumEquipmentSets() do
		local name = GetEquipmentSetInfo(i)
		local items = GetEquipmentSetItemIDs(name)
		for _, itemId in next, items do
			if not item2set[itemId] then
				item2set[itemId] = name
			else
				item2set[itemId] = item2set[itemId]..", "..name
			end
		end
	end
	print("Updating..")
end)

if IsLoggedIn() then
	f:GetScript("OnEvent")(f)
end

GameTooltip:HookScript("OnTooltipSetItem", tt)
